open Time;;

type 'a event = Event of 'a * time

let (@@) v t = Event (v, t)
let (@!) (Event (v, t)) t' = Event (v, t')
let (@+) (Event (v, t)) t' = Event (v, t + t')
let (@-) (Event (v, t)) t' = Event (v, t - t')
let (@*) (Event (v, t)) k  = Event (v, t * k )
let (@/) (Event (v, t)) k  = Event (v, t / k )
let (?@@) (Event (v, t)) = t
let (?@:) (Event (v, t)) = v

module E = struct
  let split (Event (v, t)) = (v, t)
  let v     (Event (v, _)) = v
  let t     (Event (_, t)) = t
end
