open Printf;;

        (*** refs ***)

let finc dx rx =  rx := !rx +. dx
let fdec dx rx =  rx := !rx -. dx

        (*** integer ***)

(* 0 <= result < m *)
let mod_floor x m =
  let r = x mod m
  in if (r < 0) then (r + m) else r

        (*** floating point ***)

let pi = 2.0 *. (asin 1.0)

let int = truncate

(* integer part is rounded down *)
let modf_floor x = 
  let f = floor x in (f, x-.f)

let frac x = x -. (floor x)

let modfi x = 
  let (octf, focti) = modf x
  in (octf, int focti)

(* 0 <= result < m *)
let mod_float_floor x m = 
  let r = mod_float x m
  in if (r < 0.0) then (r +. m) else r

(* integers get decremented *)
let floor_intdown x = 
  let fx = floor x
  in if (x = fx) then (x -. 1.0) else x


        (*** i/o ***)

let eprintf stuff = 
  let gunk = printf stuff
  in (flush stdout; gunk)

        (*** fnal ***)

let id x = x

(* lifts a 2-op curried fn to work on options,
 * propagating None values.
 *)
let opt_lift2 f = 
  fun x y -> 
    (match (x, y) with
      (Some x', Some y') -> Some (f x' y')
    | _ -> None
    )
